function writeanno(outname)

addpath([cd '/VOCcode']);
VOCinit;

% load image set
[ids, gt]=textread('VOC2010/ImageSets/Main/trainval.txt','%s %d');

for i=1:length(ids)
    % read annotation
    rec = PASreadrecord(sprintf(VOCopts.annopath,ids{i}));
    
    fpfile = fopen(sprintf('%s/%s.txt', outname, ids{i}), 'w');
    
    fprintf(fpfile, '%s\n', rec.filename);
    fprintf(fpfile, '%d %d %d\n', rec.imgsize(2), rec.imgsize(1), rec.imgsize(3));
    fprintf(fpfile, '%d\n', length(rec.objects));
    
    if (rec.imgsize(3) ~= 3)
         fprintf('%s\n', rec.filename);
    end
    
    for j=1:length(rec.objects)
        fprintf(fpfile, '\n');
        fprintf(fpfile, '%s\n', rec.objects(j).class);
        fprintf(fpfile, '%s\n', rec.objects(j).view);
        fprintf(fpfile, '%d %d\n', rec.objects(j).truncated, rec.objects(j).difficult);
        fprintf(fpfile, '%d ', 4);
        fprintf(fpfile, '%d %d ', rec.objects(j).bbox(1), rec.objects(j).bbox(2));
        fprintf(fpfile, '%d %d ', rec.objects(j).bbox(1), rec.objects(j).bbox(4));
        fprintf(fpfile, '%d %d ', rec.objects(j).bbox(3), rec.objects(j).bbox(4));
        fprintf(fpfile, '%d %d ', rec.objects(j).bbox(3), rec.objects(j).bbox(2));
        fprintf(fpfile, '\n');
    end
    
    fclose(fpfile);
end