#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include "common.h"
#include "OrModel.h"
#include "FilterLib\\TMatrix.h"
#include "FilterLib\\ImageEx.h"

using	namespace	std;

class CAndModel
{
	public:
		CAndModel(void);
		~CAndModel(void);

	public:
		vector<int>			ChildSet;					// children nodes
		int					Level;						// level
		int					NodeID;						// id
		int					Partner;					// the id of symmetrical node
		int					Parent;						// the id of parent node
		int					PosX, PosY, SizeX, SizeY;	// position and size

		int					ViewID;						// View id
		int					Off_HoG, Off_Shp;			// the position in the concatenated vector
		int					Dim_HoG, Dim_Shp;

	public:
		vector<double>		HoG_W;						// weights of HoG feature
		vector<double>		Shp_W;						// weights of shape feature
		double				Bias;

	public:
		vector<int>			SymIdx;						// the symmetrical mappings of features 
		int					RPosX, RPosY;				// the position of node corresponding to top left corner of root node 
		int					RSizeX, RSizeY;				// the size of node

	public:
		int		ReadModel(ifstream &inModel);
		int		WriteModel(ofstream &outModel);
		int		GetSymIdx( );							// get the symmetrical mappings of HoG features

		int		InitParts(CDetectModel &DetModel, int XCnt, int YCnt, int &AndCnt, int &OrCnt);		// Initial the nodes in the model of 2 or 3 levels
		int		GetNodePos(CDetectModel &DetModel, int PreX, int PreY, int View);					// Get the position of node corresponding to top left corner of root node. This is used to find the symmetrical nodes
};
