#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include "common.h"
#include "FilterLib/TMatrix.h"

using	namespace	std;

class CAndNode
{
	public:
		CAndNode(void);
		~CAndNode(void);

	public:
		int						NodeID;
		int						HoG_L;
		int						InitX, InitY, SizeX, SizeY;

	public:
		TMatrix<double>			matSre;						// the score matrix
		TMatrix<int>			matSrcX, matSrcY;

	public:
		int		GetStepRate(int Pos_S1, int Pos_S2, int &Step);

		double	GetScore_HoG(CData &Data, vector<double> &HoG_W, int PosX, int PosY, int SizeX, int SizeY);	// calculate HoG score of one position
		int		MakeAppScore(CDetectModel &DetModel, CData &Data, CInstTree &InstTree);						// calculate HoG scores
		int		MakeShpScore(CDetectModel &DetModel, CInstTree &InstTree);									// calculate shape scores

		int		AddChdScore(CAndNode &NxtNode, int Step);													// add scores of children nodes
		int		MakeNodeScore(CDetectModel &DetModel, CData &Data, CInstTree &InstTree);					// calculate scores

		int		GetNodeRect(CDetectModel &DetModel, CData &Data, int x, int y, CRect &CurRect);				// get the bounding box of node
		int		CropNodeRect(CData &Data, CRect &CurRect);													// crop the bounding box according to the image size

		int		GetInstRects(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CInstRect &InstRect, int x, int y);	// Detect - find the bounding boxes whose score is large than a threshold
		int		GetInst_Overlap(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CSVMInst &CurInst, double &MaxS, int x, int y); // Detect - find the instance with maximum overlap (positive images)
		int		GetInst_Score(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CSVMInst &CurInst, int x, int y);	// Detect - find the instance with maximum score (positive images)
		int		GetTopInsts(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CSVMInst &CurInst, int x, int y);		// Detect - find the instances whose score is large than a threshold (negative images)
};
