#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include <cfloat>

#include "FilterLib\\CImg.h"
#include "FilterLib\\ImageEx.h"
#include "FilterLib\\TMatrix.h"
#include "FilterLib\\ExternalTools.h"

#include "HoGExtractor.h"
#include "DetectModel.h"
#include "Parameters.h"
#include "common.h"

using	namespace	std;
using	namespace	cimg_library;

class CData
{
	public:
		CData(void);
		~CData(void);

	public:
		string					strFileName;
		int						DataID;
		int						Label;
		int						InVal;
		int						BinSize_HoG;				// the size of cell of HoG

	public:
		CImg<double>			SrcImg;
		int						ImW, ImH;
		CRect					PosRect;					// ground-truth

	public:
		vector<FeaMapType>		FeaPyd;						// feature pyramid

	public:
		int		ReadSourceImage(string strFileName);		// read image
		int		ReadSourceImage( );

		int		ReadPosRect(string strFileName);
		int		WritePosRect(string strFileName);
		int		ReadSrcImgWithRect(string strFileName);
		int		WriteSrcImgWithRect(string strFileName);

		int		ExtractFeaturePyramid(int Interval, int InitScale);		// Extract feature pyramid
		void	FreePyramid( );
		void	FreeImageSpace( );

		int		ImageResize(float *pSrc, float* &pTar, int SrcH, int SrcW, int &TarH, int &TarW, float scale);

		int		DrawPosData( );
};
