#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include "FilterLib\\CImg.h"
#include "FilterLib\\ImageEx.h"
#include "FilterLib\\TMatrix.h"
#include "FilterLib\\ExternalTools.h"
#include "Data.h"
#include "Parameters.h"

using	namespace	std;
using	namespace	cimg_library;

class	CData;

class CDataSet
{
	public:
		CDataSet(void);
		~CDataSet(void);

	public:
		vector<CData>		PosSet;							// positive images
		vector<CData>		NegSet;							// negative images
		vector<int>			NegIdx;
		int					PosCnt, NegCnt;

		vector<int>			UseIdx_Pos;						// the set of positive images where there are instances whose overlap is large than 50%

	public:
		void	Clear( );
		int		SplitByAspect(vector<vector<int> > &AspectIdx, int AspectNumber);		// 
		int		GetAspect(vector<int> &AspectIndex, double &Aspect);					// get the aspect of each view
		int		GetAreaSize(vector<int> &AspectIndex, double &AreaSize);				// get height and width of each view
};
