// Detect-SVM.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Detect-SVM.h"

int _tmain(int argc, _TCHAR* argv[])
{
	CSVMDetect		Detector;
	int				OperType	= atoi(argv[1]);
	int				ret;

	CImageEx::Initialize( );
	ret	= ReadConfig( );

	if (OperType == 0)
	{
		// Get training dataset
		ret	= Detector.InitClassSet( );
		ret	= Detector.GenDataSet(g_Parameters.strTrainSetFileName);
		ret	= Detector.InitSVM( );

		// Train
		ret	= Detector.ReadModel("PASCAL_Part_Init.txt");
		ret	= Detector.TrainSVM( );
		ret	= Detector.FreeModel( );
	}

	if (OperType == 1)
	{
		// Test
		ret	= Detector.ReadModel(g_Parameters.strModelFileName);
		ret	= Detector.DetectSet(g_Parameters.strTestSetFileName);
	}

	CImageEx::Release( );
	return 0;
}

int ReadConfig(string strConfigFileName)
{
	CConfiguration		config;

	config.Load(strConfigFileName.c_str( ));

	config.GetString("strDataPathName",			g_Parameters.strDataPathName);
	config.GetString("strClassName",			g_Parameters.strClassName);
	config.GetString("strModelFileName",		g_Parameters.strModelFileName);
	config.GetString("strTrainSetFileName",		g_Parameters.strTrainSetFileName);
	config.GetString("strTestSetFileName",		g_Parameters.strTestSetFileName);

	config.GetInt("Interval_Train",				g_Parameters.Interval_Train);
	config.GetInt("Interval_Test",				g_Parameters.Interval_Test);
	config.GetInt("CellNumber_LowBound",		g_Parameters.CellNumber_LowBound);

	config.GetInt("BinSize_HoG",				g_Parameters.BinSize_HoG);
	config.GetInt("Dim_HoG",					g_Parameters.Dim_HoG);
	config.GetInt("Dim_Shape",					g_Parameters.Dim_Shape);

	config.GetInt("MaxV",						g_Parameters.MaxV);
	config.GetInt("MaxL",						g_Parameters.MaxL);
	config.GetInt("MaxR",						g_Parameters.MaxR);
	config.GetInt("MaxDetectSize",				g_Parameters.MaxDetectSize);
	config.GetInt("MinDetectSize",				g_Parameters.MinDetectSize);

	config.GetFloat("SVM_C",					g_Parameters.SVM_C);
	config.GetDouble("SMO_epsilon",				g_Parameters.SMO_epsilon);
	config.GetFloat("Bias_Node",				g_Parameters.Bias_Node);
	config.GetFloat("Bias_Neg",					g_Parameters.Bias_Neg);

	config.GetInt("MaxPerInstCnt",				g_Parameters.MaxPerInstCnt);
	config.GetInt("MaxViewInstCnt",				g_Parameters.MaxViewInstCnt);

	config.GetInt("Max_CCCP_Iter",				g_Parameters.Max_CCCP_Iter);
	config.GetInt("Max_SMO_Iter",				g_Parameters.Max_SMO_Iter);
	config.GetInt("Max_KKT_Iter",				g_Parameters.Max_KKT_Iter);

	config.GetInt("NegPicCnt_Start",			g_Parameters.NegPicCnt_Start);
	config.GetFloat("NegPicCnt_Ratio",			g_Parameters.NegPicCnt_Ratio);

	config.GetFloat("Overlap_Root",				g_Parameters.Overlap_Root);
	config.GetFloat("Overlap_NMS",				g_Parameters.Overlap_NMS);

	return	1;
}
