
#include "Stdafx.h"
#include "Configuration.h"

CConfiguration::CConfiguration( )
{
}

CConfiguration::CConfiguration(string strConfigurationFileName)
{
	this->strConfigurationFileName = strConfigurationFileName.c_str();
	fFileNameType = 0;
}

CConfiguration::CConfiguration(wstring wstrConfigurationFileName)
{
	this->wstrConfigurationFileName = wstrConfigurationFileName.c_str();
	fFileNameType = 1;
}

void CConfiguration::Load(string strConfigurationFileName)
{
	this->strConfigurationFileName = strConfigurationFileName.c_str();
	fFileNameType = 0;
	Load( );
}

void CConfiguration::Load(wstring wstrConfigurationFileName)
{
	this->wstrConfigurationFileName = wstrConfigurationFileName.c_str();
	fFileNameType = 1;
	Load( );
}

void CConfiguration::Load()
{
	ifstream inFile;
	string op,st;

	PropetyMap.clear();
	if (fFileNameType == 0)
		inFile.open(strConfigurationFileName.c_str());
	else
		inFile.open(wstrConfigurationFileName.c_str());
	while (inFile>>op>>st)
		PropetyMap[op] = st;
	inFile.clear();
	inFile.close();
}

void CConfiguration::GetAttribute(string strAttributeName, string& dstAttributeValue)
{
	map<string,string>::iterator itr = PropetyMap.find(strAttributeName);
	if (itr==PropetyMap.end())
		dstAttributeValue = "";
	else
		dstAttributeValue = itr->second;
}

void CConfiguration::GetInt(string strIntName, int& dstInt)
{
	string tmp;
	GetAttribute(strIntName,tmp);
	dstInt = atoi(tmp.c_str());
}

void CConfiguration::GetDouble(string strDoubleName, double& dstDouble)
{
	string tmp;
	GetAttribute(strDoubleName,tmp);
	dstDouble = atof(tmp.c_str());
}

void CConfiguration::GetFloat(string strDoubleName, float& dstFloat)
{
	string tmp;
	GetAttribute(strDoubleName,tmp);
	dstFloat = (float) atof(tmp.c_str());
}

void CConfiguration::GetString(string strStringName, string& dstString)
{
	GetAttribute(strStringName,dstString);
}

void CConfiguration::GetVectorInt(string strVectorName,	int& dstCount, vector<int>& dstRgInt)
{
	int i;
	char st[1000];

	GetInt(strVectorName+"Count",dstCount);
	dstRgInt.resize(dstCount);
	for ( i = 0; i < dstCount; ++i )
	{
		sprintf_s(st, 1000, "%d", i);
		GetInt(strVectorName+st,dstRgInt[i]);
	}
}

