#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>
#include "common.h"
#include "Parameters.h"
#include "FilterLib\\CImg.h"
#include "FilterLib\\TMatrix.h"

using	namespace	std;
using	namespace	cimg_library;

class CHoGExtractor
{
	public:
		CHoGExtractor(void);
		~CHoGExtractor(void);

	public:
		double		FeaStep;
		double		Boundary;
		int			MarX, MarY;
		int			Dim;
		double		eps;

	public:
		vector<pair<double, double> >		DirVec;

	public:
		// Get HoG features
		int		GetHoGMap(CImg<double> &Im, int BinSize, CImg<double> &FeaMap, int &W_HoG, int &H_HoG);
};
