#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include "common.h"
#include "OrNode.h"
#include "AndNode.h"

using	namespace	std;

class CInstTree
{
	public:
		CInstTree(void);
		~CInstTree(void);

	public:
		vector<CAndNode>		AndNodes;
		vector<COrNode>			OrNodes;

	public:
		vector<CInstRect>		InstRects;				// Bounding boxes
		vector<CInstRect>		NMSRects;				// Bounding boxes after NMS

	public:
		int		Init(CDetectModel &DetModel);
		int		NonMaxSupp(double NMSThres);			// Non-Maximum suppression

		int		Detect(CDetectModel &DetModel, CData &Data, int InVal);						// Detect - find the bounding boxes whose score is large than a threshold
		int		GetInst_Overlap(CDetectModel &DetModel, CData &Data, CSVMInst &CurInst);	// Detect - find the instance with maximum overlap (positive images)
		int		GetInst_Score(CDetectModel &DetModel, CData &Data, CSVMInst &CurInst);		// Detect - find the instance with maximum score (positive images)
		int		GetTopInsts(CDetectModel &DetModel, CData &Data, vector<CSVMInst> &InstSet, int &InstIdx, double Thres);	// Detect - find the instances whose score is large than a threshold (negative images)

		int		InitNode(CDetectModel &DetModel, CData &Data, int Level);					// Initialization for inference	
		int		MakeAppScore(CDetectModel &DetModel, CData &Data, int Level);				// calculate the appearence scores

		// output
		int		PrintLocSet(CData &Data, int &PosCnt);
		int		PrintInstRects(string strFileName, ofstream &outRes);
		int		PrintContextRects(CData &Data, string strPathName);
		int		DrawInstRects(CDetectModel &DetModel, CData &Data, CInstRect &CurRet);
};
