#include "StdAfx.h"
#include "OrModel.h"
#include "DetectModel.h"

COrModel::COrModel(void)
{
	NodeID	= -1;
	ChildSet.clear( );
}

COrModel::~COrModel(void)
{
}

int COrModel::ReadModel(ifstream &inModel)
{
	int		Count;

	inModel>>NodeID;
	inModel>>Count;
	ChildSet.resize(Count);
	for ( int t = 0; t < Count; t++ )
	{
		inModel>>ChildSet[t];
	}

	return	1;
}

int COrModel::WriteModel(ofstream &outModel)
{
	int		Count	= (int) ChildSet.size( );

	outModel<<setw(8)<<NodeID;
	outModel<<setw(8)<<Count;
	for ( int t = 0; t < Count; t++ )
	{
		outModel<<setw(8)<<ChildSet[t];
	}
	outModel<<endl;

	return	1;
}

// Initialization of model
int COrModel::InitParts(CDetectModel &DetModel, int XCnt, int YCnt, int &AndCnt, int &OrCnt)
{
	int		CCnt	= (int) ChildSet.size( );
	int		NodeID;
	int		ret;

	for ( int t = 0; t < CCnt; t++ )
	{
		NodeID	= ChildSet[t];
		ret		= DetModel.AndModels[NodeID].InitParts(DetModel, XCnt, YCnt, AndCnt, OrCnt);
	}

	return	1;
}

// Get the position of node corresponding to top left corner of root node. This is used to find the symmetrical nodes
int COrModel::GetNodePos(CDetectModel &DetModel)
{
	int		CCnt	= (int) ChildSet.size( );
	int		NodeID;
	int		ret;

	for ( int t = 0; t < CCnt; t++ )
	{
		NodeID	= ChildSet[t];
		ret		= DetModel.AndModels[NodeID].GetNodePos(DetModel, 0, 0, t);
	}

	return	1;
}