#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include "common.h"

using	namespace	std;

class COrNode
{
	public:
		COrNode(void);
		~COrNode(void);

	public:
		int		NodeID;

	public:
		// calculate scores (HoG + Shape)
		int		MakeNodeScore(CDetectModel &DetModel, CData &Data, CInstTree &InstTree);

		// Detect - find the bounding boxes whose score is large than a threshold
		int		GetInstRects(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, double Thres);

		// Detect - find the instance with maximum overlap (positive images)
		int		GetInst_Overlap(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CSVMInst &CurInst, double &MaxS);

		// Detect - find the instance with maximum score (positive images)
		int		GetInst_Score(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, CSVMInst &CurInst);

		// Detect - find the instances whose score is large than a threshold (negative images)
		int		GetTopInsts(CDetectModel &DetModel, CData &Data, CInstTree &InstTree, vector<CSVMInst> &InstSet, int &InstIdx, double Thres);
};
