#include "StdAfx.h"
#include "Parameters.h"

CParameters		g_Parameters;

CParameters::CParameters(void)
{
	int		ret;

	timer1.Reset( );
	timer2.Reset( );
	timer3.Reset( );
	timer4.Reset( );

	ret				= SetColors( );
	ret				= SetRColors( );
	epsilon			= 1e-5f;
	SMO_epsilon		= 0.01;
	Diff_KKT		= 1e-5f;

	MarX			= 8;
	MarY			= 8;

	NullInstScore	= -10000;

	MaxInstCnt		= 1000;
	MaxInstSetCnt	= 50000;
}

CParameters::~CParameters(void)
{
}

int CParameters::SetColors( )
{
	Colors.clear( );

	Colors.push_back(Color(  0,255,  0));
	Colors.push_back(Color(  0,  0,255));
	Colors.push_back(Color(255,  0,  0));

	Colors.push_back(Color(255, 64,  0));
	Colors.push_back(Color(255,128,  0));
	Colors.push_back(Color(255,192,  0));
	Colors.push_back(Color(255,255,  0));
	Colors.push_back(Color(192,255,  0));
	Colors.push_back(Color(128,255,  0));
	Colors.push_back(Color( 64,255,  0));

	Colors.push_back(Color(  0,255, 64));
	Colors.push_back(Color(  0,255,128));
	Colors.push_back(Color(  0,255,192));
	Colors.push_back(Color(  0,255,255));
	Colors.push_back(Color(  0,192,255));
	Colors.push_back(Color(  0,128,255));
	Colors.push_back(Color(  0, 64,255));

	Colors.push_back(Color( 64,  0,255));
	Colors.push_back(Color(128,  0,255));
	Colors.push_back(Color(192,  0,255));
	Colors.push_back(Color(255,  0,255));
	Colors.push_back(Color(255,  0,192));
	Colors.push_back(Color(255,  0,128));
	Colors.push_back(Color(255,  0, 64));
	
	return	1;
}

int CParameters::SetRColors( )
{
	RColors.clear( );
	for ( int R = 0; R < 255; R += 60 )
	{
		for ( int G = 0; G < 255; G += 60 )
		{
			for ( int B = 0; B < 255; B += 60 )
			{
				RColors.push_back(Color(R, G, B));
			}
		}
	}

	random_shuffle(RColors.begin( ), RColors.end( ));
	return	1;
}