#pragma once

#include <string>
#include <vector>
#include <limits>
#include <cmath>
#include "FilterLib\\CImg.h"
#include "FilterLib\\ImageEx.h"
#include "FilterLib\\TMatrix.h"
#include "FilterLib\\ExternalTools.h"
#include "Parameters.h"

using	namespace	std;
using	namespace	cimg_library;

class CPascalData
{
	public:
		typedef	struct tagAnnoObject
		{
			vector<CPoint>			points;
			string					strTagName;
			string					strPoseStatus;
			int						CateID;
			int						Truncated, Difficult;
		} AnnoObjectType;

	public:
		CPascalData(void);
		~CPascalData(void);

	public:
		vector<AnnoObjectType>		Objects;
		vector<CRect>				Rects;
		string						strImageFileName;
		int							Height, Width, Depth;

	public:
		CImg<double>	CropImg;
		CRect			PosRect;

	public:
		int		ReadAnnotation(string strFileName);					// Read file of annotations
		int		GetUseObject(vector<string> &CateSet);				// remove useless objects
		bool	InCategoryNameSet(string strObjectName, vector<string> &CateSet);

		int		SavePosRect(string strRectFileName, CRect PosRect);

		int		Clip(int RectID);
		int		Flip( );
		int		Save(string strFileName);

		void	UnifyString(string &strName);
};
