#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>

#include "FilterLib\\CImg.h"
#include "FilterLib\\ImageEx.h"
#include "FilterLib\\TMatrix.h"
#include "FilterLib\\ExternalTools.h"
#include "Data.h"
#include "DataSet.h"
#include "InstTree.h"
#include "PascalData.h"
#include "DetectModel.h"
#include "Parameters.h"

using	namespace	std;
using	namespace	cimg_library;

class CSVMDetect
{
	public:
		CSVMDetect(void);
		~CSVMDetect(void);

	public:
		CDetectModel		DetModel;
		CDataSet			DataSet;

	public:
		vector<string>		CategorySet;

	public:
		int		InitClassSet( );
		int		ReadModel(string strModelName);
		int		FreeModel( );

		int		GenDataSet(string strDataSetName);		// generate dataset for training
		int		InitSVM( );								// initial model
		int		TrainSVM( );							// training

		int		ReadSet( );
		int		DetectSet(string strImageSetName);		// testing
};
