#pragma once

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include "common.h"

using	namespace	std;

class	CDetectModel;
class	CInstTree;
class	CData;

class CSVMInst
{
	public:
		CSVMInst(void);
		~CSVMInst(void);

	public:
		double				Score_Loss;
		double				Score_SVM;
		double				Score_KKT;					// LossScore + SVMScore
		double				Alpha;

		int					Label;
		int					DataID;
		int					Lvl, PosX, PosY;
		double				LRCmp;

		vector<int>			NodeXY;
		double				*pHoG;
		double				*pShp;
		int					ViewID;
		int					SymID;
		int					Index;

		CRect				DetRect;

	public:
		int		Init(CDetectModel &DetModel);
		int		GetLRCmp(CDetectModel &DetModel);

		int		AllocMemory(CDetectModel &DetModel);
		int		FreeMemory( );

		int		GetShpFea(CDetectModel &DetModel, CInstTree &InstTree, int NodeID, int x, int y);		// calculate shape features
		int		GetAppFea(CDetectModel &DetModel, CData &Data, CInstTree &InstTree);					// calculate hog features
};
